<script setup>
    import {ref} from 'vue';
    let taskList =ref([]);
    let task = ref('');

const addTask = () => {
    if (task.value.trim()===''){
             alert('empty');               //checks if the input is empty
             return false;
         }
    if (validateTask(task.value)) {
      let id = taskList.value.length; //Get the length of the id
      console.log(id);
      taskList.value.push({             //The value of task will be added to the taskList
        id: ++id,                       //Increment id if btn addtask is clicked
        content: task.value,
        is_done: false
      })
      task.value = ''                 //The input field will be null after a successfull add of task
    }

  }

  const validateTask = (new_task) => {
    let index = taskList.value.findIndex((t) => t.content === new_task); //Find the index value of added task
    if (index !== -1) {     //If index is not equal to -1 then it is duplicated. 
      alert("task already exist!");
      return false;
    } else {
      return true;
    }
  }
 
  let selectedTask = ref('');
  const selectTask = (row) => {         //If selected task is clicked the value will be passed to the input field
    selectedTask.value = row;
    task.value = row.content;
  }
  const updateTask = () => {
    if (validateTask(task.value)) {
      let index = taskList.value.findIndex((t) => t.id === selectedTask.value.id); //Checks if taskList id matched the id of selectedtask
      index !== -1 && (taskList.value[index].content = task.value);
      task.value = selectedTask.value = '';                                        //If match then the selectedtask can be updated
    }
  }
  const markAsDone = (row) => {
    if (confirm(`Are you sure you want to mark ${row.content} as done?`)) {
      let index = taskList.value.findIndex((t) => t.id === row.id); //The button class change to success changed when is_done is true
      index !== -1 && (taskList.value[index].is_done = true);
    }
  }
  const removeTask = (row) => {
    if (confirm(`Are you sure you want to delete ${row.content}?`)) {  
      let index = taskList.value.findIndex((t) => t.id === row.id); //Finds the id of taskList then splice the selected id to remove it to the taskList
      index !== -1 && taskList.value.splice(index, 1);
    }
  }


</script>

<template>
<main class="app" id="app">
    <section class="task">
        <div class="d-flex justify-content-center container">
            <div class="w-75">
                <form  @submit.prevent="!selectedTask ? addTask() : updateTask()"> <!--If the input field value is not from selecttask then the function that will trigger is addtask Else it trigger the updatetask function -->
                    <div class="mb-3 mt-5">
                        <label class="qTd" for="">Whats your to do?</label>
                        <div class="d-flex">
                            <input type="text" class="form-control" id="task" placeholder="eg. Create task application" v-model="task">
                            <button  v-if="!selectedTask" type="submit" class="btn btn-primary ms-3"><svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-plus-lg" viewBox="0 0 16 16">
                            <path fill-rule="evenodd" d="M8 2a.5.5 0 0 1 .5.5v5h5a.5.5 0 0 1 0 1h-5v5a.5.5 0 0 1-1 0v-5h-5a.5.5 0 0 1 0-1h5v-5A.5.5 0 0 1 8 2Z"/>
                            </svg></button>
                            <button  v-else  type="submit" class="btn btn-primary ms-3"><svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-pencil-square" viewBox="0 0 16 16">
                            <path d="M15.502 1.94a.5.5 0 0 1 0 .706L14.459 3.69l-2-2L13.502.646a.5.5 0 0 1 .707 0l1.293 1.293zm-1.75 2.456-2-2L4.939 9.21a.5.5 0 0 0-.121.196l-.805 2.414a.25.25 0 0 0 .316.316l2.414-.805a.5.5 0 0 0 .196-.12l6.813-6.814z"/>
                            <path fill-rule="evenodd" d="M1 13.5A1.5 1.5 0 0 0 2.5 15h11a1.5 1.5 0 0 0 1.5-1.5v-6a.5.5 0 0 0-1 0v6a.5.5 0 0 1-.5.5h-11a.5.5 0 0 1-.5-.5v-11a.5.5 0 0 1 .5-.5H9a.5.5 0 0 0 0-1H2.5A1.5 1.5 0 0 0 1 2.5v11z"/>
                            </svg></button>
                        </div>
                    </div>
                </form>
                <div @click="selectTask(row)"  v-for="row in taskList" :key="row.id"  class="toast show mt-2 w-100"><!--Use to display the entered task-->
                    <div class="toast-header">
                    <strong class="me-auto">{{row.content}}</strong><!--Shows the task task that is pushed to the taskList-->
                    <button :class="`btn btn-${row.is_done ? 'success' : 'outline-secondary'} btn-sm`" @click.stop="markAsDone(row)"><svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-check-lg" viewBox="0 0 16 16">
                    <path d="M12.736 3.97a.733.733 0 0 1 1.047 0c.286.289.29.756.01 1.05L7.88 12.01a.733.733 0 0 1-1.065.02L3.217 8.384a.757.757 0 0 1 0-1.06.733.733 0 0 1 1.047 0l3.052 3.093 5.4-6.425a.247.247 0 0 1 .02-.022Z"/>
                    </svg></button>
                    <button class="btn btn-danger btn-sm ms-1" @click.stop="removeTask(row)"><svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-dash" viewBox="0 0 16 16">
                    <path d="M4 8a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7A.5.5 0 0 1 4 8z"/>
                    </svg></button>
                </div>
                </div>
            </div>
        </div>
    </section>
</main>
</template>


